



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JS 优化条件语句的5个技巧</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JS 优化条件语句的5个技巧</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-19 01:34:04 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前言</h2>
<p>在使用 JavaScript 的时候，有时我们会处理大量条件语句，这里有5个技巧帮助我们编写更简洁的条件语句。</p>
<h2>一、对多个条件使用 Array.includes</h2>
<p>例子：</p>
<div>
<pre class="prettyprint linenums">function condition(fruit) {<br />
  if (fruit == 'apple' || fruit == 'banana') {<br />
    console.log(fruit);<br />
  }<br />
}</pre>
</div>
<p>上面的例子看起来不错，但如果有更多水果需要判断呢，比如桃子、草莓、橙子等等，我们要用更多的 || 来扩展这个表述吗？</p>
<p>我们可以使用 <strong>Array.includes</strong> 重写上面的条件</p>
<div>
<pre class="prettyprint linenums">function condition(fruit){<br />
    const allFruit = ['apple','banana','peach'，'Strawberry','orange'];<br />
    if(allFruit.includes(fruit)){<br />
        console.log(fruit)<br />
    }<br />
}</pre>
</div>
<p>这样做之后，代码看起来更简洁。</p>
<h2>二、更少的嵌套，尽早返回</h2>
<p>例子：</p>
<div>
<pre class="prettyprint linenums">// 尽早返回不存在的条件

function condition(fruit, quantity) {<br />
    const allFruits = ['apple','banana','peach'，'Strawberry','orange'];

    if (!fruit) throw new Error('No fruit!');

    if (allFruits.includes(fruit)) {<br />
        console.log(fruit); 

        if (quantity &gt; 10) {<br />
            console.log(quantity);<br />
        }

    }<br />
}     </pre>
</div>
<p>通过反转条件和提早返回，我们可以进一步减少嵌套：</p>
<div>
<pre class="prettyprint linenums">function condition(fruit, quantity) {<br />
    const allFruits = ['apple','banana','peach'，'Strawberry','orange'];

    if (!fruit) throw new Error('No fruit!');

    if (!allFruits.includes(fruit)) return ;

    console.log(fruit)

    if (quantity &gt; 10) {<br />
        console.log(quantity);<br />
    }<br />
}  </pre>
</div>
<h2>三、使用默认的函数参数和解构</h2>
<p>例子：</p>
<div>
<pre class="prettyprint linenums">function condition(fruit, quantity) {<br />
  if (!fruit) return;<br />
  const q = quantity || 1; 

  console.log(`We have ${q} ${fruit}!`);<br />
}

condition('banana'); // We have 1 banana!<br />
condition('apple', 2); // We have 2 apple!</pre>
</div>
<p>使用默认参数和解构：</p>
<div>
<pre class="prettyprint linenums">function condition({name} = {}, quantity = 1) {<br />
  console.log (name || 'unknown');<br />
}

condition(undefined); // unknown<br />
condition({ }); // unknown<br />
condition({ name: 'apple', color: 'red' }); // apple</pre>
</div>
<h2>四、选择 Map 或对象字面量，而不是 Switch 语句</h2>
<p>例子：</p>
<div>
<pre class="prettyprint linenums">function condition(color) {<br />
  switch (color) {<br />
    case 'red':<br />
      return ['apple', 'strawberry'];<br />
    case 'yellow':<br />
      return ['banana', 'pineapple'];<br />
    case 'purple':<br />
      return ['grape', 'plum'];<br />
    default:<br />
      return [];<br />
  }<br />
}

condition(null); // []<br />
condition('yellow'); // ['banana', 'pineapple']</pre>
</div>
<p>上面的代码似乎没有什么问题，但我发现它相当冗长。同样的结果可以通过对象字面量和更简洁的语法来实现：</p>
<p>对象字面量：</p>
<div>
<pre class="prettyprint linenums">const fruitColor = {<br />
   red: ['apple', 'strawberry'],<br />
   yellow: ['banana', 'pineapple'],<br />
   purple: ['grape', 'plum']<br />
};

function condition(color) {<br />
  return fruitColor[color] || [];<br />
}</pre>
</div>
<p>使用 Map 实现相同效果：</p>
<div>
<pre class="prettyprint linenums">const fruitColor = new Map()<br />
    .set('red', ['apple', 'strawberry'])<br />
    .set('yellow', ['banana', 'pineapple'])<br />
    .set('purple', ['grape', 'plum']);

function condition(color) {<br />
  return fruitColor.get(color) || [];<br />
}</pre>
</div>
<p>使用 Array.filter</p>
<div>
<pre class="prettyprint linenums">const fruits = [<br />
   { name: 'apple', color: 'red' },<br />
   { name: 'strawberry', color: 'red' },<br />
   { name: 'banana', color: 'yellow' },<br />
   { name: 'pineapple', color: 'yellow' },<br />
   { name: 'grape', color: 'purple' },<br />
   { name: 'plum', color: 'purple' }<br />
];

function condition(color) {<br />
 return fruits.filter(f =&gt; f.color == color);<br />
}</pre>
</div>
<h2>五、所有或部分使用 Array.every &amp; Array.some 的条件</h2>
<p>例子：</p>
<p>检查所有水果都为红色：</p>
<div>
<pre class="prettyprint linenums">const fruits = [<br />
    { name: 'apple', color: 'red' },<br />
    { name: 'banana', color: 'yellow' },<br />
    { name: 'grape', color: 'purple' }<br />
  ];

function condition() {<br />
  let isAllRed = true;

  for (let f of fruits) {<br />
    if (!isAllRed) break;<br />
    isAllRed = (f.color == 'red');<br />
  }

  console.log(isAllRed); // false<br />
}</pre>
</div>
<p>代码太长了！我们可以用<strong> Array.every</strong> 来减少行数：</p>
<div>
<pre class="prettyprint linenums">const fruits = [<br />
    { name: 'apple', color: 'red' },<br />
    { name: 'banana', color: 'yellow' },<br />
    { name: 'grape', color: 'purple' }<br />
  ];

function test() {<br />
  const isAllRed = fruits.every(f =&gt; f.color == 'red');

  console.log(isAllRed); // false<br />
}</pre>
</div>
<p>如果我们想用一行代码来判断任何一个水果是否为红色，我们可以使用 Array.some<code><br /></code></p>
<div>
<pre class="prettyprint linenums">const fruits = [<br />
    { name: 'apple', color: 'red' },<br />
    { name: 'banana', color: 'yellow' },<br />
    { name: 'grape', color: 'purple' }<br />
];

function condition() {<br />
  const isAnyRed = fruits.some(f =&gt; f.color == 'red');

  console.log(isAnyRed); // true<br />
}</pre>
</div>
<h5>随笔整理自</h5>
<h5>　　<a href="http://blog.jobbole.com/114671/" rel="external nofollow noreferrer">http://blog.jobbole.com/114671/</a></h5>
<h5>感谢博主分享！</h5>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4yznjq.html">mac下查看&period;mobileprovision文件及钥匙串中证书&period;cer文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96pxxn8.html">ubuntu 16&period;04  Dockerfile 安装mysql</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn54mxq.html">mysql数据库的导入导出</a>
		</li>
						<li><a href="https://www.batexi.com/a/495ye0zq.html">关于Thread&period;Sleep&lpar;0&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0133q.html">CentOS6&period;5菜鸟之旅：关于搜索的shell命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j000zwq.html">用ActionSupport实现验证</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn2y4v8.html">c语言学习的第五天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd53gl8.html">App Submission Issues</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xvlx09.html">SaaS系列介绍之十三&colon; SaaS系统体系架构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmxpee9.html">react native for  Android （make you first  android app）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m77l38.html">poj 1050 To the Max&lpar;线性dp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojjxjpq.html">数独  &lpar;dfs&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljnvj69.html">一起学JUCE之Atomic</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy10l1dq.html">jQuery实现checkbox即点即改，批量计数，以及中间遇到的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vdkm8.html">DNS 访问 Service - 每天5分钟玩转 Docker 容器技术（138）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw327z8.html">获取gcc和clang的内置宏定义</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7odml18.html">nginx &amp;amp&semi;&amp;amp&semi; apache 图片代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1gvy49.html">BugPhobia开发篇章：Beta阶段第IX次Scrum Meeting</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zy2wwn9.html">vue-cli之webpack的proxyTable无效的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2yd1o9.html">win10常用命令和设置总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/90mzy548.html">&lbrack;SDOI2018&rsqb; 战略游戏</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzwdg48.html">关于mysql-connector-net和C&num;&period;net</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z63o19.html">mybatis基础（中）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zrwmn9.html">Python 面向对象之反射</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me3z76q.html">17 ， CSS 区块、浮动、定位、溢出、滚动条</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16n61q.html">hbuilder vs2013api   Access-Control-Allow-Origin</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16og1q.html">记录自己使用GitHub的点点滴滴</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k0xn49.html">linux下编译opencv</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1m3nmq.html">postman测试方法，出现400错误码</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzre5q.html">前端js面向对象编程以及封装组件的思想</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
